﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart;
using Steema.TeeChart.Drawing;
using Steema.TeeChart.Styles;
using Steema.TeeChart.Tools;
using System.Threading;

namespace TestBarChart
{
	public partial class Form1 : Form
	{
		private delegate void ChangeValueDelegate();
		int randomSeed = 112736456;
		Series series1, series2;
		private Thread workerThread = null;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			tChart1.Aspect.View3D = false;
			//tChart1.Axes.Left.Automatic = false;
			//tChart1.Axes.Left.AutomaticMaximum = false;
			//tChart1.Axes.Left.AutomaticMinimum = false;
			//tChart1.Axes.Left.Increment = 10;
			//tChart1.Axes.Left.Maximum = 0;
			//tChart1.Axes.Left.Minimum = 0;
			//tChart1.Axes.Left.MinorTickCount = 4;
			tChart1.Axes.Bottom.Title.Caption = "bottom";
			tChart1.Axes.Bottom.Automatic = true;
			tChart1.Axes.Bottom.AutomaticMaximum = true;
			tChart1.Axes.Bottom.AutomaticMinimum = true;
			tChart1.Axes.Left.Labels.ValueFormat = "";
			tChart1.Axes.Left.Automatic = true;
			tChart1.Axes.Left.AutomaticMaximum = true;
			tChart1.Axes.Left.AutomaticMinimum = true;
			tChart1.Axes.Left.Title.Caption = "";
			tChart1.Graphics3D.BufferStyle = BufferStyle.DoubleBuffer;
			
			series1 = AddSeries(-30, -20);
            series2 = AddSeries(-40, -20);

			workerThread = new Thread(new ThreadStart(WorkerThread));
			workerThread.Start();
		}

		private Series AddSeries(int min, int max)
		{
			Random r = new Random(randomSeed--);
			Bar bar = new Bar();
			bar.UseOrigin = false;
			bar.BarWidthPercent = 70;
			bar.Pen.Visible = false;
			Series series = bar;
			tChart1.Series.Add(series);

			for (int i = 0; i < 2; i++)
			{
				double y = r.Next(min, max);
				int x = i;
				series.Add(x, y);
			}

			(series as Bar).MultiBar = Steema.TeeChart.Styles.MultiBars.SideAll;

			return series;
		}

		private void UpdateSeries(Series series, int min, int max)
		{
			Random r = new Random(randomSeed--);

			for (int i = 0; i < 2; i++)
			{
				double y = r.Next(min, max);
				int x = i;
				series.YValues[i] = y;
			}
		}

		private void WorkerThread()
		{
			try
			{
				while (true)
				{
					BeginInvoke(new ChangeValueDelegate(ChangeValue));

					Thread.Sleep(100);
				}
			}
			catch
			{
			}
		}

		private void ChangeValue()
		{
            try
            {
                UpdateSeries(series1, -30, -20);
                UpdateSeries(series2, -40, -20);
                tChart1.Refresh();
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.WriteLine(ex.ToString());
            }

		}
	}
}
